
/* cift3-c.c -- CIF test 3, C part */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "cifccsp.h"

void out_string (char *str, Channel *out)
{
	unsigned char *ch = (unsigned char *)str;

	while (*ch != '\0') {
		/* ChanOut (out, ch, 1); */
		ChanOutChar (out, *ch);
		ch++;
	}
	return;
}

void proc_p1 (Process *me, Channel *out)
{
	int i;

	for (i=0; i<10; i++) {
		ChanOutInt (out, i);
	}
	ChanOutInt (out, -1);
	return;
}

void proc_p2 (Process *me, Channel *in, Channel *out)
{
	int v;
	char str[20];

	do {
		ChanInInt (in, &v);
		EXTERNAL_CALLN (sprintf, str, "%d\n", v);
		out_string (str, out);
	} while (v > -1);
	return;
}

void my_process (Process *me, Channel *kroc_err)
{
	Process *p1, *p2;
	Channel c;

	ChanInit (&c);
	out_string ("Hello, world! (from C).  Allocating some other processes and going parallel..\n", kroc_err);
	p1 = ProcAlloc (proc_p1, 4096, 1, &c);
	p2 = ProcAlloc (proc_p2, 4096, 2, &c, kroc_err);
	ProcPar (p1, p2, NULL);
	ProcAllocClean (p1);
	ProcAllocClean (p2);
	return;
}


/* allocates process and returns address to occam world */
void real_cift3_init (int *raddr, Channel *c)
{
	Process *p = ProcAlloc (my_process, 4096, 1, c);

	*raddr = (int)p;
	return;
}

/* frees memory used by a process -- lets hope it's finished :) */
void real_cift3_free (int addr)
{
	Process *p = (Process *)addr;

	ProcAllocClean (p);
	return;
}

void _cift3_init (int *ws) { real_cift3_init ((int *)(ws[0]), (Channel *)(ws[1])); }
void _cift3_free (int *ws) { real_cift3_free ((int)(ws[0])); }

